%bcond_with   		uclibc
%define Werror_cflags	%{nil}
%define _ssp_cflags	%{nil}

Summary:	Multi-call binary combining many common Unix tools into one executable
Name:		busybox
Epoch:		1
# stick to stable releases, usually minor number is even
Version:	1.34.1
%define         subrel 1
Release:	%mkrel 1
License:	GPLv2
Group:		Shells
URL:		http://www.busybox.net/
Source0:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2
Source1:	http://www.busybox.net/downloads/%{name}-%{version}.tar.bz2.sig
Patch0:		busybox-1.31.1-stime-fix.patch
Source2:	busybox-1.15.2-config
Source3:	busybox-1.17.2-minimal-config
Patch1:		busybox-i.15.2-no-march_i386.patch
Patch12:	busybox-1.2.2-ls.patch
Patch17:	busybox-1.26.2-use-Os.diff
Patch19:	busybox-1.27.2-CVE-2014-9645.patch
Patch23:	busybox-1.24.2-CVE-2016-6301.patch
# Patches from Alpine Linux for CVE-2022-28391
Patch100:       https://git.alpinelinux.org/aports/plain/main/busybox/0001-libbb-sockaddr2str-ensure-only-printable-characters-.patch
Patch101:       https://git.alpinelinux.org/aports/plain/main/busybox/0002-nslookup-sanitize-all-printed-strings-with-printable.patch

BuildRequires:	gcc >= 3.3.1-2mdk
BuildRequires:	pkgconfig(libtirpc)
%if %{with uclibc}
BuildRequires:	uClibc-static-devel >= 0.9.30.3-3
%define __cc	%{uclibc_cc}
%define	cflags	%{uclibc_cflags}
%else
BuildRequires:	glibc-static-devel
%define	cflags	%{optflags}
%endif
BuildRequires:	kernel-userspace-headers

%description
BusyBox combines tiny versions of many common UNIX utilities into a
single small executable. It provides minimalist replacements for most
of the utilities you usually find in GNU coreutils, shellutils, etc.
The utilities in BusyBox generally have fewer options than their
full-featured GNU cousins; however, the options that are included provide
the expected functionality and behave very much like their GNU counterparts.
BusyBox provides a fairly complete POSIX environment for any small or
embedded system.

BusyBox has been written with size-optimization and limited resources in
mind. It is also extremely modular so you can easily include or exclude
commands (or features) at compile time. This makes it easy to customize
your embedded systems. To create a working system, just add /dev, /etc,
and a kernel.

%package	static
Group:		Shells
Summary:	Static linked busybox

%description	static
This package contains a static linked busybox.

%prep
%setup -q
%patch0 -p1 -b .stime
%patch1 -b .no_march~ -p1
%patch12 -b .ls~ -p1
%patch17 -b .Os~ -p1
%patch19 -p1 -b .modprobe
%patch23 -p1 -b .ntpd-dos
%patch100 -p1
%patch101 -p1

%build
cat %{SOURCE2} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make_build oldconfig V=1
%make_build CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.full.static
sed -i "s|^.*CONFIG_EXTRA_CFLAGS=\"|CONFIG_EXTRA_CFLAGS=\"$(pkg-config  libtirpc --cflags)|g" .config
%make_build CC=%{__cc} LDFLAGS="%{ldflags} $(shell pkg-config  libtirpc --cflags)" V=1 CONFIG_STATIC=n
mv busybox_unstripped busybox.full


%if %{with uclibc}
cat %{SOURCE3} |sed \
	-e 's|^.*CONFIG_EXTRA_CFLAGS.*$|CONFIG_EXTRA_CFLAGS="%{cflags} -fno-strict-aliasing"|g' \
	> .config
yes "" | %make_build oldconfig V=1
%make_build CC=%{__cc} LDFLAGS="%{ldflags}" V=1
mv busybox_unstripped busybox.minimal.static
%make_build CC=%{__cc} LDFLAGS="%{ldflags}" V=1 CONFIG_STATIC=n
mv busybox_unstripped busybox.minimal
%endif

%check
# FIXME
%if 0
%make_build CC=%{__cc} V=1 check
%endif

%install
install -m755 busybox.full -D %{buildroot}%{_bindir}/busybox
install -m755 busybox.full.static -D %{buildroot}/bin/busybox.static
%if %{with uclibc}
install -m755 busybox.minimal -D %{buildroot}%{uclibc_root}%{_bindir}/busybox.minimal
install -m755 busybox.minimal.static -D %{buildroot}%{uclibc_root}/bin/busybox.minimal.static
%endif

%files
%doc AUTHORS README TODO
%{_bindir}/busybox
%if %{with uclibc}
%{uclibc_root}%{_bindir}/busybox.minimal
%endif

%files static
%doc AUTHORS README TODO
/bin/busybox.static
%if %{with uclibc}
%{uclibc_root}/bin/busybox.minimal.static
%endif


%changelog
* Wed Apr 06 2022 kekepower <kekepower> 1:1.34.1-1.1.mga8
+ Revision: 1846270
- Add patches from Alpine Linux for CVE-2022-28391 (mga#30246)
+ ns80 <ns80>
- new version 1.34.1 for CVE-2021-4237[6-9] and CVE-2021-4238[0-6] (mga#29697)
+ luigiwalser <luigiwalser>
- add patch from fedora to fix CVE-2021-28831

* Fri Jan 01 2021 luigiwalser <luigiwalser> 1:1.32.1-1.mga8
+ Revision: 1667980
- 1.32.1

* Wed Dec 30 2020 kekepower <kekepower> 1:1.33.0-1.mga8
+ Revision: 1665584
- Update to version 1.33.0

* Fri Nov 27 2020 tmb <tmb> 1:1.32.0-3.mga8
+ Revision: 1649770
- rebuild for missing signature

* Wed Nov 25 2020 tv <tv> 1:1.32.0-2.mga8
+ Revision: 1649336
- fix compiling dynamic version with tirpc/glibc-2.32
- disable rpc stuff in static version (glibc-2.32...)

* Sun Jun 28 2020 kekepower <kekepower> 1:1.32.0-1.mga8
+ Revision: 1600109
- Update to version 1.32.0

* Tue Feb 18 2020 umeabot <umeabot> 1:1.31.1-2.mga8
+ Revision: 1538117
- Mageia 8 Mass Rebuild

* Thu Nov 14 2019 daviddavid <daviddavid> 1:1.31.1-1.mga8
+ Revision: 1459930
- new version: 1.31.1

* Thu Feb 14 2019 kekepower <kekepower> 1:1.30.1-1.mga7
+ Revision: 1367064
- Update to version 1.30.1

* Sun Dec 30 2018 kekepower <kekepower> 1:1.30.0-1.mga7
+ Revision: 1347253
- Update to versino 1.30.0
- Rediffed Patch1

* Sat Sep 22 2018 umeabot <umeabot> 1:1.28.4-2.mga7
+ Revision: 1295748
- Mageia 7 Mass Rebuild

* Fri May 25 2018 kekepower <kekepower> 1:1.28.4-1.mga7
+ Revision: 1232094
- Update to version 1.28.4

* Wed Apr 04 2018 kekepower <kekepower> 1:1.28.3-1.mga7
+ Revision: 1215278
- Update to version 1.28.3

* Tue Mar 27 2018 kekepower <kekepower> 1:1.28.2-1.mga7
+ Revision: 1212858
- Update to version 1.28.2

* Sun Feb 18 2018 kekepower <kekepower> 1:1.28.1-1.mga7
+ Revision: 1202770
- Update to version 1.28.1
- Revert to last version as 1.28.0 is an unstable release
- Updated to version 1.28.0

* Wed Oct 25 2017 mjack <mjack> 1:1.27.2-1.mga7
+ Revision: 1173745
- Updated to version 1.27.2
- Rediffed patch: CVE-2014-9645.patch

* Thu Sep 21 2017 tv <tv> 1:1.26.2-1.mga7
+ Revision: 1156732
- new release
- rediff -Os patch
- drop merged patch
- use new build macros (thus fixing build)

* Thu Aug 04 2016 luigiwalser <luigiwalser> 1:1.24.2-2.mga6
+ Revision: 1044429
- add upstream patch to fix CVE-2016-6301

* Fri Mar 18 2016 luigiwalser <luigiwalser> 1:1.24.2-1.mga6
+ Revision: 992836
- 1.24.2
- remove upstream patch 20

* Mon Mar 14 2016 luigiwalser <luigiwalser> 1:1.24.1-2.mga6
+ Revision: 990565
- add upstream patches to fix CVE-2016-2147 and CVE-2016-2148

* Sat Dec 26 2015 luigiwalser <luigiwalser> 1:1.24.1-1.mga6
+ Revision: 915270
- 1.24.1

* Wed Oct 28 2015 luigiwalser <luigiwalser> 1:1.23.2-2.mga6
+ Revision: 896066
- add upstream patch to fix segfault in unzip

* Sat Jul 25 2015 blino <blino> 1:1.23.2-1.mga6
+ Revision: 857328
- 1.23.2
- remove merged/fixed patches

* Mon Jan 26 2015 luigiwalser <luigiwalser> 1:1.22.1-5.mga5
+ Revision: 812345
- add upstream patch to fix CVE-2014-9645

* Wed Oct 15 2014 umeabot <umeabot> 1:1.22.1-4.mga5
+ Revision: 738800
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1:1.22.1-3.mga5
+ Revision: 678252
- Mageia 5 Mass Rebuild

* Tue Aug 19 2014 luigiwalser <luigiwalser> 1:1.22.1-2.mga5
+ Revision: 665667
- add upstream patch to fix CVE-2014-4607

* Fri Feb 14 2014 luigiwalser <luigiwalser> 1:1.22.1-1.mga5
+ Revision: 591030
- 1.22.1

* Tue Nov 12 2013 tv <tv> 1:1.21.1-3.mga4
+ Revision: 550841
- patch 17: uses -Os
- disable uClibc build (trades 41k of overhead in busybox for saving 444k of
  dynamic uclibc in stage2: we don't want _both_ glibc & uclibc!)

* Sat Oct 19 2013 umeabot <umeabot> 1:1.21.1-2.mga4
+ Revision: 528921
- Mageia 4 Mass Rebuild

* Sat Jun 29 2013 fwang <fwang> 1:1.21.1-1.mga4
+ Revision: 448336
- new version 1.21.1

* Fri Jan 11 2013 umeabot <umeabot> 1:1.20.2-2.mga3
+ Revision: 347231
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jul 17 2012 rtp <rtp> 1:1.20.2-1.mga3
+ Revision: 271832
- bump dep on uClibc to get suitable headers
+ luigiwalser <luigiwalser>
- 1.20.2
- try different patches to not use missing header
- add BuildRequires kernel-userspace-headers and upstream patch to fix build
- re-diff patch from upstream to fix CVE-2011-2716

* Fri Jan 06 2012 shlomif <shlomif> 1:1.19.3-1.mga2
+ Revision: 192380
- New busybox version - 1.19.3

* Wed Apr 13 2011 tv <tv> 1:1.18.4-1.mga1
+ Revision: 84497
- drop patches 100-103 (merged upstream)
- new release

* Thu Jan 27 2011 erwan <erwan> 1:1.18.2-2.mga1
+ Revision: 42223
- Fixing typo
- Rebuild
- Adding latest patches

* Thu Jan 27 2011 erwan <erwan> 1:1.18.2-1.mga1
+ Revision: 42215
- imported package busybox

